Imports System.Data
Imports AmazonWS

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim aws As New AWSECommerceService()
        Dim request As New ItemSearchRequest()

        request.SearchIndex = "Music"
        request.Keywords = TextBox1.Text
        request.ResponseGroup = New String() {"Medium"}
        request.Sort = "salesrank"

        Dim requests() As ItemSearchRequest = {request}

        Dim itemSearch As New ItemSearch
        'Ensure to register and receive your subscription ID for Amazon Web Service
        'http://www.amazon.com/gp/aws/registration/registration-form.html
        'USE YOUR ID TO SETTING UP THE FOLLOWING PROPERTY
        itemSearch.SubscriptionId = "YOUR ID HERE"
        itemSearch.Request = requests

        Try

            Dim response As ItemSearchResponse = aws.ItemSearch(itemSearch)
            Dim info As Items = response.Items(0)
            Dim items() As Item = info.Item

            If (items.Length > 0) Then
                Dim albums As DataTable = Me.MusicData()

                Dim i As Integer
                For i = 0 To items.Length - 1
                    Dim item As Item = items(i)

                    Dim dr As DataRow = albums.NewRow()
                    dr("Title") = item.ItemAttributes.Title
                    If Not item.MediumImage Is Nothing Then
                        dr("ImageUrl") = item.MediumImage.URL
                    End If
                    dr("Price") = item.ItemAttributes.ListPrice.FormattedPrice
                    If Not item.ItemAttributes.Artist Is Nothing Then
                        dr("Artist") = item.ItemAttributes.Artist(0)
                    End If

                    albums.Rows.Add(dr)
                Next

                DataList1.DataSource = albums
                DataList1.DataBind()

                DataList1.Visible = True
                Label1.Visible = False
            Else
                DataList1.Visible = False
                Label1.Visible = True
                Label1.Text = "Your search - " + TextBox1.Text + " - did not match any music titles."
            End If

        Catch ex As Exception
            Label1.Text = ex.ToString()
            DataList1.Visible = False
        End Try

    End Sub

    Private Function MusicData() As DataTable
        Dim dt As New DataTable("Music")

        dt.Columns.Add(New DataColumn("Title", GetType(String)))
        dt.Columns.Add(New DataColumn("ImageUrl", GetType(String)))
        dt.Columns.Add(New DataColumn("Price", GetType(String)))
        dt.Columns.Add(New DataColumn("Artist", GetType(String)))

        Return dt
    End Function

End Class
